const purchases = [
  `id`,
  `lotNumber`,
  `expire`,
  `received`,
  `quantity`,
  `purchaseCost`,
  `invoiceNumber`,
  `vendor`,
  `location`,
  `pricePerUnit`,
  `inStock`
];
const medications = [
  `id`,
  `purchase{
    id
    inventory{
      id
      name
      brand
      dose
      instruction
      distributionUnit
      salePricePerUnit
    }
  }`,
  `dispense`,
  `description`,
  `status`,
  `prescriberId`
];
export default {
  data: [
    `id`,
    `groupId`,
    `patientId`,
    `followUpId`,
    `medications{
${medications.map(v => v)}
  }`,
    `invoice{id}`,
    `patient{
      firstNameEn
      lastNameEn
      hn
      id
    }`
  ],
  list: [
    `id`,
    `patient{
      firstNameEn
      lastNameEn
      hn
      id
    }`,
    `updated`
  ],
  inventories: [
    `name`,
    `id`,
    `groupId`,
    `description`,
    `distributionUnit`,
    `dose`,
    `brand`,
    `categories`,
    `salePricePerUnit`,
    `instruction`,
    `inStock`
  ],
  inventory: [
    `name`,
    `id`,
    `groupId`,
    `description`,
    `distributionUnit`,
    `rank`,
    `crossReference`,
    `reorderPoint`,
    `salePricePerUnit`,
    `dose`,
    `instruction`,
    `brand`,
    `categories`,
    `salePricePerUnit`,
    `inStock`,
    `purchases(size:1000){
      ${purchases.map(v => v)}
    }`
  ],
  purchases: purchases,
  medications: medications,
  invoices: [
    `id`,
    `type`,
    `visit{
      id
    }`
  ],
  invoice: [
    `id`,
    `type`,
    `visit{
      id
    }`,
    `medications{
      id
      dispense
      status
      description
      purchase{
        id
        inventory{
          id
          name
          brand
          dose
          instruction
          distributionUnit
        }
      }
    }`
  ]
};
