const logbook_procedures = [
  `
  procedure{
    minRequire
    id
    name
  }`,
  `additional`,
  `id{
    procedureId
    logbookId
  }`
];
const logbook_diseases = [
  `
  disease{
    minRequire
    id
    name
  }`,
  `additional`,
  `id{
    diseaseId
    logbookId
  }`
];
const comment = [
  `comment`,
  `id`,
  `action`,
  `user{
    titleTh
    firstNameTh
    lastNameEn
    username
  }`
];
export default {
  list: [
    `id`,
    `hn`,
    `performedDate`,
    `advisor{
    titleTh
    username
    firstNameTh
    lastNameTh
  }`,
    `teacher{
    titleTh
    username
    firstNameTh
    lastNameTh
  }`,
    `user{
  titleTh
  username
  firstNameTh
  lastNameTh
}`,
    `currentValidated{
      status
      by
      validatedDate
    }`
  ],
  data: [
    `id`,
    `hn`,
    `performedDate`,
    `name`,
    `patientType`,
    `stateOfLife`,
    `procedureType`,
    `place`,
    `diagnosis`,
    `physicalInformation`,
    `investigation`,
    `management`,
    `counseling`,
    `user{
  titleTh
  username
  firstNameTh
  lastNameTh
}`,
    `files{
      file {
        id
        name
      }
    }`,
    `advisor{
      titleTh
      username
      firstNameTh
      lastNameTh
    }`,
    `teacher{
      titleTh
      username
      firstNameTh
      lastNameTh
    }`,
    `note`,
    `logbookProcedures(size:100){
      ${logbook_procedures.map(v => v)}
    }`,
    `logbookDiseases(size:100){
      ${logbook_diseases.map(v => v)}
    }`,
    `logbookFormResponses {
      id {
      logbookId
      formResponseId
    }
    formResponse{
      id,
      form{
        id
        title
      }
      requestUser{
        username
        firstNameTh
        lastNameTh
        titleTh
      }
      responseUser{
        username
        firstNameTh
        lastNameTh
        titleTh
      }
      score,
      updatedOn
    }
  }`,

    `logbookComments(size:100){
    ${comment.map(v => v)}
  }`,
    `currentValidated{
      status
      by
      validatedDate
    }`
  ],
  procedures: [`id`, `name`, `procedures{id name minRequire code}`],
  logbook_procedures: logbook_procedures,
  logbook_diseases: logbook_diseases,
  logbook_form: [
    `logbook{
      id
      hn
      performedDate
      files{
      file {
        id
        name
      }
    }
      user{
    titleTh
    username
    firstNameTh
    lastNameTh
  }
  note
  logbookProcedures(size:100){
    ${logbook_procedures.map(v => v)}
  }
  logbookDiseases(size:100){
    ${logbook_diseases.map(v => v)}
  }
    }`
  ],
  logbook_manages: [
    `id`,
    `specialty{
      nameEn
    }`,
    `items`,
    `patientTypes`,
    `procedureTypes`,
    `stateOfLifes`
  ],
  comment: comment,
  diseases: [
    `id`,
    `name`,
    `code`,
    `diseases{
      minRequire
      id
      name
      code
    }`
  ],
  institute: [
    `id`,
    `hn`,
    `performedDate`,
    `advisor{
    titleTh
    username
    firstNameTh
    lastNameTh
  }`,
    `teacher{
    titleTh
    username
    firstNameTh
    lastNameTh
  }`,
    `user{
  titleTh
  username
  firstNameTh
  lastNameTh
}`,
    `currentValidated{
      status
      by
      validatedDate
    }`
  ],
};
