export default {
  list: [
    `id`,
    `nameEn`,
    `nameTh`,
    `majorId`,
    `user{
      username
      firstNameTh
      lastNameTh
      firstNameEn
      lastNameEn
      titleTh
      yearEnrolled
    }`,
    `coUsers{
      nameTh
      nameEn
    }`,
    `committees{
      username
      firstNameTh
      lastNameTh
      titleTh
      yearEnrolled
    }`,
    `currentStatus`,
    `currentResearchForm{
      id
      status
    }`,
    `isPass`,
    `updatedOn`
  ],
  data: [
    `id`,
    `nameEn`,
    `nameTh`,
    `majorId`,
    `user{
      username
      firstNameTh
      lastNameTh
      titleTh
      yearEnrolled
      firstNameEn
      lastNameEn
    }`,
    `coUsers{
      nameTh
      nameEn
      role
      institute
      hospital
    }`,
    `committees{
      username
      firstNameTh
      lastNameTh
      titleTh
      yearEnrolled
    }`,
    `evaluations{
      isPass
      user{
        username
        firstNameTh
        lastNameTh
        titleTh
      }
    }`,
    `currentStatus`,
    `currentResearchForm{
      id
      status
    }`,
    `place`,
    `location{
      lat
      lng
    }`,
    `start`,
    `end`,
    `researchForms{
      id
      status
      updatedOn
    }`,
    `isPass`,
    `comments{
      id
      comment
      user{
        username
        firstNameTh
        lastNameTh
      }
    }`,
    `manuScriptForms{
      id
      status
    }`,
    `currentManuScriptForm{
      id
      status
    }`
  ],
  forms: [`id`, `status`, `updatedOn`],
  form: [
    `id`,
    `background`,
    `literatureReview`,
    `primaryObjective`,
    `secondaryObject`,
    `researchQuestion`,
    `hypothesis`,
    `conceptualFramework`,
    `studyDesign`,
    `generalizability`,
    `targetPopulation`,
    `studyPopulation`,
    `samplingPopulation`,
    `inclusionCriteria`,
    `exclusionCriteria`,
    `samplingCalculationReference`,
    `samplingCalculationDefinition`,
    `samplingCalculationEquation`,
    `method`,
    `operationDefinition`,
    `studyFactor`,
    `outcomeMeasurement`,
    `primaryOutcome`,
    `secondaryOutcome`,
    `demographicAnalysis`,
    `inferentialStatistic`,
    `dummyTable`,
    `ethicConsideration`,
    `referenceBudget`,
    `timelines{
      title
      start
      end
    }`,
    `status`,
    `budgets{
      title
      money
    }`,
    `reference`,
    `createdOn`,
    `updatedOn`,
    `guaranteeAppendix{
      file{
        id
        name
        alias
      }
    }`,
    `associatedAppendix{
      file{
        id
        name
        alias
      }
    }`,
    `recordFormAppendix{
      file{
        id
        name
        alias
      }
    }`,
    `informationAppendix{
      file{
        id
        name
        alias
      }
    }`,
    `informConsentAppendix{
      file{
        id
        name
        alias
      }
    }`,
    `researchCurriculumVitae{
      file{
        id
        name
        alias
      }
    }`
  ],
  comments: [
    `id`,
    `comment`,
    `user{
      username
      firstNameTh
      lastNameTh
    }`
  ],
  evaluations: [
    `id`,
    `user{
      username
      firstNameTh
      lastNameTh
    }`,
    `evaluations{
      score{
        score
      }
    }`
  ],
  evaluation: [
    `id`,
    `researchId`,
    `evaluations{
      id
      title
      score{
        id
        score
      }
      min
      max
    }
    `,
    `userId`
  ],
  manu_script: [
    `id`,
    `status`,
    `title`,
    `coUsers{
        nameTh
        nameEn
        institute
        hospital
        role
      }`,
    `address`,
    `abs`,
    `keywords`,
    `introduction`,
    `methods`,
    `results`,
    `discussion`,
    `conclusion`,
    `acknowlegement`,
    `references`,
    `reference`
  ],
  form_evaluations: [`id`, `title`, `min`, `max`],
  form_evaluation: [`id`, `score`],
  manages: [
    `id`,
    `name`,
    `yearEnrolled`,
    `start`,
    `end`,
    `activities(sortBy:"expectedDate",size:1000){
      id
      nameTh
     	expiredDate
      expectedDate
    }`
  ],
  activities: [
    `id`,
    `nameTh`,
    `expectedDate`,
    `expiredDate`,
    `manageResearch{id yearEnrolled end start name}`
  ],
  manage_activity: [
    `submitted`,
    `id{
      activityId
    }`,
    `verifier{
      username
      firstNameEn
      lastNameEn
    }`,
    `verifiedDate`,
    `files{
      file{
        id
        name
      }
      submitted
    }`
  ]
};
