const courses = [
  `id`,
  `courseNo`,
  `year`,
  `descriptionTh`,
  `nameAbbr`,
  `nameTh`,
  `credits`,
  `semester`,
  `specialty{
  id
  nameEn
  nameTh
  code
}`
];
const kpis = [
  `id`,
  `name`,
  `description`,
  `code`,
  `number`,
  `fileNames{
    id
      fileNameTh
      fileNameEn
    }`,
  `formId`
];
export default {
  filesNames: [
    `id`,
    `name`,
    `kpiFileNames{
      id
      fileNameTh
      fileNameGuides
      relatedKpis{
        code
        name
        number
      }
    }`
  ],
  curriculums: [
    `id`,
    `nameTh`,
    `revisionYear`,
    `degreeTh`,
    `degreeAbbrTh`,
    `code`,
    `degreeType`,
    `curriculumYear`,
    `courses(size:100){
      ${courses.map(v => v)}
    }`
  ],
  kpis: kpis,
  kpi: kpis,
  courses: courses,
  course: courses,
  offers: [
    `id`,
    `course{
      ${courses.map(v => v)}
    }`,
    `academicYear`,
    `semesterCode`,
    `kpiAnswerStatus`
  ],
  offer: [
    `id`,
    `course{
      ${courses.map(v => v)}
    }`,
    `kpiAnswerStatus`,
    `bundles{
      course{
        nameAbbr
        nameTh
        courseNo
      }
      academicYear
      semesterCode
    }`,
    `academicYear`,
    `semesterCode`,
    `instructors{
      user{
        id
        username
        firstNameTh
        lastNameTh
      }
      roles
    }`,
    `requiredKpis{
      ${kpis.map(v => v)}
    }`,
    `outcomeAnswers{
      outcome{
        title
        id
      }
      answer
    }`,
    `kpiFiles{
      kpiFileName {
        id
        fileNameTh
        fileNameEn
      }
      files{
        id
        originalFilename
      }
    }`,
    `kpiAnswers{
      hasAnswer
      formResponse{
        id
        formId
      }
      kpi{
        ${kpis.map(v => v)}
      }
      fileIds
    }`
  ],
  answers: [
    `id`,
    `status`,
    `kpi{
      id
      code
      number
      name
    }`,
    `hasAnswer`
  ],
  answer: [
    `id`,
    `status`,
    `evidences {
      filename
      fileId
    }`,
    `hasAnswer`,
    `kpi{
      id
      code
      number
      name
      formId
    }`,
    `responseId`,
    `courseOffer{
      id
      course{
        courseKpis{
         kpi{
          id
          name
          code
          number
          filenames
          formId
        }
        }
      }
    }`
  ],
  outcome: [
    `outcome{
    id
  }`,
    `answer`
  ],
  outcomes: [`title`, `id`],
  responses: [`kpiId`, `formResponseId`],
  outcome_forms: [
    `id {
      courseOfferId
      kpiId
      outcomeId
    }`,
    `teachingMethod`,
    `assessmentMethod`,
    `outcome{
      id
      title
    }`
  ]
};
