import { EXAM_API } from "../actions/actionType";
import Super from "./super";
const defaultState = {
  list: [],
  data: {},
  users: [],
  user: {},
  opnotes: {},
  questions: [],
  problemUser: [],
  students: [],
  formQuestion: []
};

export default (state = defaultState, action) => {
  let reducer = new Super(state, action);
  switch (action.type) {
    case EXAM_API.OPNOTE.DEL.SUCCESS:
      return {
        ...state,
        data: {
          ...state.data,
          opnotes: state.data.opnotes.filter(v => v.id !== action.data)
        }
      };
    case EXAM_API.STUDENT.POST.SUCCESS:
      return reducer.post("users");
    case EXAM_API.STUDENT.CLEAR.SUCCESS:
      return { ...state, users: [] };
    case EXAM_API.SELF.ALL.SUCCESS:
      return reducer.list();
    case EXAM_API.SELF.GET.SUCCESS:
      return reducer.get();
    case EXAM_API.SELF.POST.SUCCESS:
      return reducer.post();
    case EXAM_API.SELF.PUT.SUCCESS:
      return reducer.put();
    case EXAM_API.SELF.CLEAR.SUCCESS:
      return { ...state, list: [], students: [] };
    case EXAM_API.USER.POST.SUCCESS:
      return { ...state, problemUser: action.data };
    case EXAM_API.USER.GET.SUCCESS:
      return reducer.get("user");
    case EXAM_API.USER.PUT.SUCCESS:
      return reducer.put("user");
    case EXAM_API.USER.CLEAR.SUCCESS:
      return { ...state, users: [] };
    case EXAM_API.USER.ALL.SUCCESS:
      var key = "users";
      var record = state;
      record[key] = state[key]
        .concat(
          (action.data ? action.data : [])
            .map((v, i) => ({
              ...v
            }))
            .filter(
              v =>
                state[key].filter(
                  value => value.student.username === v.student.username
                ).length === 0
            )
        )
        .map(v =>
          action.data.filter(m => m.student.username === v.student.username)
            .length > 0
            ? {
                ...action.data.filter(
                  m => m.student.username === v.student.username
                )[0]
              }
            : { ...v }
        );
      return { ...record };
    case EXAM_API.OPNOTE.POST.SUCCESS:
      return {
        ...state,
        data: { ...state.data, opnotes: [action.data, ...state.data.opnotes] }
      };
    case EXAM_API.QUESTION.ALL.SUCCESS:
      return reducer.list("questions");
    case EXAM_API.QUESTION.DEL.SUCCESS:
      return {
        ...state,
        data: {
          ...state.data,
          questions: state.data.questions.filter(
            v => v.question.id !== action.data
          )
        }
      };
    case EXAM_API.PROBLEM.ALL.SUCCESS:
      var key = "problemUser";
      var record = state;
      record[key] = state[key]
        .concat(
          (action.data ? action.data : [])
            .map((v, i) => ({
              ...v
            }))
            .filter(
              v =>
                state[key].filter(
                  value => value.student.username === v.student.username
                ).length === 0
            )
        )
        .map(v =>
          action.data.filter(m => m.student.username === v.student.username)
            .length > 0
            ? {
                ...action.data.filter(
                  m => m.student.username === v.student.username
                )[0]
              }
            : { ...v }
        );
      return { ...record };
    case EXAM_API.STUDENT.ALL.SUCCESS:
      var key = "students";
      var record = state;
      record[key] = state[key]
        .concat(
          (action.data ? action.data : [])
            .map((v, i) => ({
              ...v
            }))
            .filter(
              v =>
                state[key].filter(
                  value => value.student.username === v.student.username
                ).length === 0
            )
        )
        .map(v =>
          action.data.filter(m => m.student.username === v.student.username)
            .length > 0
            ? {
                ...action.data.filter(
                  m => m.student.username === v.student.username
                )[0]
              }
            : { ...v }
        );
      return { ...record };
    case EXAM_API.FORM_QUESTION.POST.SUCCESS:
      return {
        ...state,
        user: {
          ...state.user,
          examination: {
            ...state.user.examination,
            questions: state.user.examination.questions.map(v =>
              v.question.id === action.data.questionId
                ? {
                    ...v,
                    meResponses: v.meResponses
                      ? [...v.meResponses, action.data]
                      : [],
                    responses: v.responses ? [...v.responses, action.data] : []
                  }
                : { ...v }
            )
          }
        }
      };
    case EXAM_API.FORM_QUESTION.DEL.SUCCESS:
      return {
        ...state,
        user: {
          ...state.user,
          examination: {
            ...state.user.examination,
            questions: state.user.examination.questions.map(v =>
              v.question.id === action.questionId
                ? {
                    ...v,
                    responses: v.responses.filter(e => e.id !== action.data)
                  }
                : { ...v }
            )
          }
        }
      };
    case EXAM_API.FORM_OPNOTE.POST.SUCCESS:
      return {
        ...state,
        user: {
          ...state.user,
          examination: {
            ...state.user.examination,
            opnotes: state.user.examination.opnotes.map(v =>
              v.id === action.data.oralExaminationOpnoteId
                ? {
                    ...v,
                    meResponses: v.meResponses
                      ? [...v.meResponses, action.data]
                      : [],
                    responses: v.responses ? [...v.responses, action.data] : []
                  }
                : { ...v }
            )
          }
        }
      };
    case EXAM_API.FORM_OPNOTE.DEL.SUCCESS:
      return {
        ...state,
        user: {
          ...state.user,
          examination: {
            ...state.user.examination,
            opnotes: state.user.examination.opnotes.map(v =>
              v.id === action.opnoteId
                ? {
                    ...v,
                    responses: v.responses.filter(e => e.id !== action.data)
                  }
                : { ...v }
            )
          }
        }
      };
    default:
      return state;
  }
};
