import { GROUP_API } from "../actions/actionType";
import Super from "./super";
import moment from "moment";
const defaultState = {
  list: [],
  data: {}
};
export default (state = defaultState, action) => {
  let reducer = new Super(state, action);
  switch (action.type) {
    case GROUP_API.SELF.ALL.SUCCESS:
      return reducer.list();
    case GROUP_API.SELF.GET.SUCCESS:
      return reducer.get();
    case GROUP_API.SELF.POST.SUCCESS:
      return reducer.post();
    case GROUP_API.SELF.PUT.SUCCESS:
      return reducer.put();
    case GROUP_API.SELF.CLEAR.SUCCESS:
      return reducer.clear();
    case GROUP_API.MEMBER.POST.SUCCESS:
      return {
        ...state,
        data: { ...state.data, members: [...state.data.members, action.data] }
      };
    case GROUP_API.FORM.POST.SUCCESS:
      return {
        ...state,
        data: { ...state.data, items: [...state.data.items, action.data] }
      };
    case GROUP_API.MEMBER.DEL.SUCCESS:
      return {
        ...state,
        data: {
          ...state.data,
          members: state.data.members.filter(v => v.user.id != action.data)
        }
      };
    case GROUP_API.MEMBER.PUT.SUCCESS:
      return {
        ...state,
        data: {
          ...state.data,
          members: state.data.members.map(v =>
            v.user.id === action.data.user.id ? { ...action.data } : { ...v }
          )
        }
      };
    default:
      return state;
  }
};
