export default class Super {
  constructor(state, action) {
    this.state = state;
    this.action = action;
  }
  get(key = "data") {
    var record = this.state;
    record[key] = this.action.data;
    return { ...record };
  }
  search(key = "list") {
    var record = this.state;
    record[key] = this.action.data;
    return { ...record };
  }
  list(key = "list", val = "id") {
    var record = this.state;
    record[key] = this.state[key]
      .concat(
        (this.action.data ? this.action.data : [])
          .map((v, i) => ({
            ...v
          }))
          .filter(
            v =>
              this.state[key].filter(value => value[val] === v[val]).length ===
              0
          )
      )
      .map(v =>
        this.action.data.filter(m => m[val] === v[val]).length > 0
          ? { ...this.action.data.filter(m => m[val] === v[val])[0] }
          : { ...v }
      );
    return { ...record };
  }
  clear(key = "list") {
    var record = this.state;
    record[key] = [];
    return { ...record };
  }
  post(key = "list") {
    var record = this.state;
    record[key] = [this.action.data, ...this.state[key]];
    return { ...record };
  }
  push(key = "list") {
    var record = this.state;
    record[key] = [...this.state[key], this.action.data];
    return { ...record };
  }
  put(key = "data", list = "list") {
    var record = this.state;
    record[key] = this.action.data;
    record[list] = record[list].map(v =>
      v.id === this.action.data.id ? { ...this.action.data } : { ...v }
    );
    return { ...record };
  }
  delete(key = "list") {
    var record = this.state;
    record[key] = this.state[key].filter(v => v.id !== this.action.data);
    return { ...record };
  }
  insertOrUpdate(key = "list") {
    var record = this.state;
    record[key] = this.action.data;
    return { ...record };
  }
}
