import { call, fork, put, takeEvery } from "redux-saga/effects";
import { ALL, CLEAR, COMPONENT, DEL, DETAIL, GET, POST, PUT, SEARCH, SELF,CONTACT_API,CONTACT_REQUEST } from "../actions/actionType.js";
import graphql from "../services/graphql";
  const url = "specialty";
  function* callback(isSuccess, error) {
    isSuccess
      ? yield put({
          type: COMPONENT.CALLBACK_SUCCESS
        })
      : yield put({
          type: COMPONENT.CALLBACK_FAIL,
          data: error.response.data.message
        });
    yield put({
      type: COMPONENT.SUCCESS
    });
  }
  function* loading() {
    yield put({
      type: COMPONENT.CALLBACK_LOADING
    });
  }
  function* complete() {
    yield put({
      type: COMPONENT.SUCCESS
    });
  }
  function* outOfRange() {
    yield put({
      type: COMPONENT.CALLBACK_OUT
    });
  }
  function* renew() {
    yield put({
      type: COMPONENT.CALLBACK_NEW
    });
  }
  function* priority() {
    yield put({
      type: COMPONENT.CALLBACK_PRIORITY
    });
  }
  function* clearPriority() {
    yield put({
      type: COMPONENT.CALLBACK_CLEAR
    });
  }
  function* request(actions) {
    switch (actions.api) {
      case GET:
        return yield fork(get, actions);
      case POST:
        return yield fork(post, actions);
      case PUT:
        return yield fork(change, actions);
      case DEL:
        return yield fork(del, actions);
      case ALL:
        return yield fork(getAll, actions);
      case SEARCH:
        return yield fork(search, actions);
      case CLEAR:
        return yield fork(clear, actions);
      default:
        null;
    }
  }
  function* clear(actions) {
    try {
      switch (actions.doc) {
        case SELF:
          return yield put({
            type: CONTACT_API.SELF.CLEAR.SUCCESS
          });
        default:
          null;
      }
    } catch (e) {
      console.log(e);
      yield call(callback, false, e);
    }
  }
  function* getAll(actions) {
    try {
      switch (actions.doc) {
    
        default:
          null;
      }
    } catch (e) {
      console.log(e);
      yield call(callback, false, e);
    }
  }
  function* get(actions) {
    try {
      switch (actions.doc) {
        case SELF:
          var response = yield call(
            graphql.get,
            `specialty(id:"${actions.id}")`,
            url,
            actions
          );
          yield put({
            type: CONTACT_API.SELF.GET.SUCCESS,
            data: response.data.data.specialty
          });
          return yield call(complete);
        default:
          null;
      }
    } catch (e) {
      console.log(e);
      yield call(callback, false, e);
    }
  }
  function* post(actions) {
    try {
      switch (actions.doc) {
        case SELF:
          yield call(loading);
          var response = yield call(graphql.post, "Specialty", url, actions);
          yield put({
            type: CONTACT_API.SELF.POST.SUCCESS,
            data: response.data.data.insertSpecialty
          });
          return yield call(complete);
        default:
          null;
      }
    } catch (e) {
      console.log(e);
      yield call(callback, false, e);
    }
  }
  function* change(actions) {
    try {
      switch (actions.doc) {
        case SELF:
          var response = yield call(graphql.put, "Specialty", url, actions);
          yield put({
            type: CONTACT_API.SELF.PUT.SUCCESS,
            data: response.data.data.updateSpecialty
          });
          yield call(callback, true);
          return yield call(complete);
        default:
          null;
      }
    } catch (e) {
      console.log(e);
      yield call(callback, false, e);
    }
  }
  
  function* del(actions) {
    try {
      switch (actions.doc) {
        
        default:
          null;
      }
    } catch (e) {
      console.log(e);
      yield call(callback, false, e);
    }
  }
  function* search(actions) {
    try {
      switch (actions.doc) {
        default:
          null;
      }
    } catch (e) {
      console.log(e);
      yield call(callback, false, e);
    }
  }
  export function* watchContact() {
    yield takeEvery(CONTACT_REQUEST, request);
  }
  