import {
  COMPONENT,
  GET,
  POST,
  PUT,
  DEL,
  ALL,
  SPECIALTY_API,
  SPECIALTY_REQUEST,
  SELF,
  REDIRECT_TO,
  SEARCH,
  FORM,
  CLONE,
  COMPARE
} from "../actions/actionType.js";
import { put, fork, call, take, takeEvery } from "redux-saga/effects";
import graphql from "../services/graphql";
import query from "query";
const url = "specialty";
function* callback(isSuccess, error) {
  isSuccess
    ? yield put({
        type: COMPONENT.CALLBACK_SUCCESS
      })
    : yield put({
        type: COMPONENT.CALLBACK_FAIL,
        data: error.response.data.message
      });
  yield put({
    type: COMPONENT.SUCCESS
  });
}
function* loading() {
  yield put({
    type: COMPONENT.CALLBACK_LOADING
  });
}
function* complete() {
  yield put({
    type: COMPONENT.SUCCESS
  });
}
function* outOfRange() {
  yield put({
    type: COMPONENT.CALLBACK_OUT
  });
}
function* renew() {
  yield put({
    type: COMPONENT.CALLBACK_NEW
  });
}
function* request(actions) {
  switch (actions.api) {
    case GET:
      return yield fork(get, actions);
    case POST:
      return yield fork(post, actions);
    case PUT:
      return yield fork(change, actions);
    case DEL:
      return yield fork(del, actions);
    case ALL:
      return yield fork(getAll, actions);
    case SEARCH:
      return yield fork(search, actions);
    default:
      null;
  }
}
function* getAll(actions) {
  try {
    switch (actions.doc) {
      case SELF:
        yield call(loading);
        if (actions.obj) {
          if (actions.obj.isRest) {
            var response = yield call(
              graphql.getRest,
              "/specialty/specialties",
              actions.item
            );
            console.log('wow')
            return yield put({
              type: SPECIALTY_API.SELF.ALL.SUCCESS,
              data: response.data
            });
          }
        }
        console.log('w')
        var response = yield call(
          graphql.search,
          "specialties",
          0,
          100,
          url,
          actions
        );
        if (actions.item.skip == 0) {
          yield put({
            type: SPECIALTY_API.CLEAR.ALL.SUCCESS,
            data: []
          });
          yield call(renew);
        }
        var reseaches = response.data.data.specialties;
        yield put({
          type: SPECIALTY_API.SELF.ALL.SUCCESS,
          data: reseaches
        });
        if (reseaches.length == 0) {
          return yield call(outOfRange);
        } else {
          return yield call(complete);
        }
      default:
        null;
    }
  } catch (e) {
    console.log(e);
    yield call(callback, false, e);
  }
}
function* get(actions) {
  try {
    switch (actions.doc) {
      default:
        null;
    }
  } catch (e) {
    console.log(e);
    yield call(callback, false, e);
  }
}
function* post(actions) {
  yield call(loading);
  try {
    switch (actions.doc) {
      default:
        null;
    }
  } catch (e) {
    console.log(e);
    yield call(callback, false, e);
  }
}
function* change(actions) {
  yield call(loading);
  try {
    switch (actions.doc) {
      default:
        null;
    }
  } catch (e) {
    console.log(e);
    yield call(callback, false, e);
  }
}
function* del(actions) {
  yield call(loading);
  try {
    switch (actions.doc) {
      default:
        null;
    }
  } catch (e) {
    console.log(e);
    yield call(callback, false, e);
  }
}
function* search(actions) {
  try {
    switch (actions.doc) {
      default:
        null;
    }
  } catch (e) {
    console.log(e);
    yield call(callback, false, e);
  }
}
export function* watchSpecialty() {
  yield takeEvery(SPECIALTY_REQUEST, request);
}
