import agent from "./agent";
export default {
  getUser(id) {
    return agent().get(`/account/users/${id}`);
  },
  getPending(id) {
    return agent().get(`/account/signups/${id}`);
  },
  getVerify(item) {
    return agent().post(`/account/signups/verify`, item);
  },
  getVerifyCode(id) {
    return agent().get(`account/signups/verifyCode/${id}`);
  },
  listUser(item) {
    return agent().get("/account/users", { params: item });
  },
  listPending(item) {
    return agent().get("/account/signups", { params: item });
  },
  listInistute() {
    return agent().get("/account/institutes",{params:{size:100}});
  },
  postUser(item) {
    return agent().post("/account/users", item);
  },
  externalSignup(item) {
    return agent().post("/auth/login/chula", item);
  },
  signup(item) {
    return agent().post("/account/signups", item);
  },
  signupVerify(item) {
    return agent().post("/account/signups/verifyCode", item);
  },
  putUser(id, item) {
    return agent().put(`/account/users/${id}`, item);
  },
  putPending(id, item) {
    return agent().post(`/account/signups/${id}/approve`, item);
  },
  putProfilePic(id, item) {
    return agent().put(`/account/users/${id}/image`, item);
  },
  delUser(id) {
    return agent().delete(`/account/users/${id}`);
  },
  delPending(id) {
    return agent().delete(`/account/signups/${id}`);
  }
};
